ace.define('ace/snippets/javascript',['require','exports','module'], function(require, exports, module) {
var s = {
	// scopes
	events:[],
	actions:[],
	js:[]
};

exports.snippetText = s;


var a = s.js;
a.push({
	title:"function StartupEvent()",
	subTitle:"Javascript, Events",
	docHTML:"<p>Executed when the interface is first loaded.\nIt's a good place to set up the interface and set variables, for example.\n</p>",
	content:"function StartupEvent() {\n\t${1:// body...} \n}"
});
a.push({
	title:"function userCommand(name, param)",
	subTitle:"Javascript, Events",
	docHTML:"<p>Called by user clicks on user buttons: <a href=\"/3.7.0/index.php/User\" title=\"User\">User</a>, <a href=\"/3.7.0/index.php/UserMini\" title=\"UserMini\" class=\"mw-redirect\">UserMini</a>, <a href=\"/3.7.0/index.php/UserMicro\" title=\"UserMicro\" class=\"mw-redirect\">UserMicro</a>, <a href=\"/3.7.0/index.php/UserRGB\" title=\"UserRGB\" class=\"mw-redirect\">UserRGB</a> or <a href=\"/3.7.0/index.php/UserImage\" title=\"UserImage\">UserImage</a> objects.\n</p><p>If you want to navigate to a specific page when the button is pressed (it would be like pressing a <a href=\"/3.7.0/index.php/Link\" title=\"Link\">Link object</a>), return a string starting with \"page:\" followed by the page name; in this case, userCommand() will be called again when that popup or page is closed, with \"/close\" appended to param.\n</p><p><b>Parameters:</b>\n</p><ul>\n<li> name: string - the name field of the user object\n</li>\n<li> param: string - the param of the user object\n</li>\n</ul><p><br>\n<b>Returns:</b>\n</p><ul>\n<li> null: proceed to send the request to server as it is\n</li>\n<li> \"\": assume the event was resolved. Don't send the request to the server\n</li>\n<li> \"page:page name\": navigate to the specified page\n</li>\n<li> \"page:back\": navigate to the previous page\n</li>\n<li> \"page:forward\": navigate to the next page\n</li>\n<li> \"page:close\": if the user button that generated the call has an open popup linked to it, close it\n</li>\n<li> \"error\": error. Don't send the request to the server\n</li>\n<li> an object, to specify new name and param values to be sent to the server\n</li>\n</ul><div dir=\"ltr\" class=\"mw-geshi mw-code mw-content-ltr\"><div class=\"javascript source-javascript\"><pre class=\"de1\"><span class=\"br0\">{</span>name<span class=\"sy0\">:</span><span class=\"st0\">\"new name\"</span><span class=\"sy0\">,</span> param<span class=\"sy0\">:</span><span class=\"st0\">\"new param\"</span><span class=\"br0\">}</span></pre></div></div>",
	content:"function userCommand(name, param) {\n\t${1:// body...} \n}"
});
a.push({
	title:"function userSubmit(name, param)",
	subTitle:"Javascript, Events",
	docHTML:"<p>Called on every submit request (from <a href=\"/3.7.0/index.php/Submit\" title=\"Submit\">Submit</a> objects).\nParameters and return values are the same as the userCommand function.\n</p>",
	content:"function userSubmit(name, param) {\n\t${1:// body...} \n}"
});
a.push({
	title:"function uiEvent(id, attr, value)",
	subTitle:"Javascript, Events",
	docHTML:"<p>Executed on every UISet received from the server, intercepts a UISet and allows to change it, prevent its execution or execute any other custom code (e.g. set variables).\n</p><p><b>Parameters:</b>\n</p><ul>\n<li> id: string - id of the ui object\n</li>\n<li> attr: string - attribute name\n</li>\n<li> value: string - new value being set\n</li>\n</ul><p><br>\n<b>Returns:</b>\n</p><ul>\n<li> null: discard the UISet\n</li>\n<li> <string>: set a new value for the UISet. To keep the UISet as it is, return the initial value\n</li>\n</ul>",
	content:"function uiEvent(id, attr, value) {\n\t${1:// body...} \n}"
});
a.push({
	title:"function pageOpenEvent(name)",
	subTitle:"Javascript, Events",
	docHTML:"<p>Called when a page is opened.\n</p><p><b>Parameters:</b>\n</p><ul>\n<li> name: string - the page's id\n</li>\n</ul><p><b>Returns:</b>\n</p><ul>\n<li> false: don't open the page. A <i>pageOpenEvent</i> is called on the previous page, as if it was reopened.\n</li>\n<li> null: proceed to open the page\n</li>\n</ul><div dir=\"ltr\" class=\"mw-geshi mw-code mw-content-ltr\"><div class=\"javascript source-javascript\"><pre class=\"de1\"><span class=\"co1\">// page open event</span>\n<span class=\"kw1\">function</span> pageOpenEvent<span class=\"br0\">(</span>name<span class=\"br0\">)</span> <span class=\"br0\">{</span>\n\tconsole.<span class=\"me1\">log</span><span class=\"br0\">(</span><span class=\"st0\">\"opening \"</span><span class=\"sy0\">+</span>name<span class=\"br0\">)</span><span class=\"sy0\">;</span>\n\t<span class=\"kw1\">if</span> <span class=\"br0\">(</span>name <span class=\"sy0\">==</span><span class=\"st0\">\"wconfig\"</span><span class=\"br0\">)</span> <span class=\"br0\">{</span>\n\t\tconsole.<span class=\"me1\">log</span><span class=\"br0\">(</span><span class=\"st0\">\"nope 1\"</span><span class=\"br0\">)</span><span class=\"sy0\">;</span>\n\t\t<span class=\"kw1\">return</span> <span class=\"kw2\">false</span><span class=\"sy0\">;</span>\n\t<span class=\"br0\">}</span>\n<span class=\"br0\">}</span></pre></div></div>",
	content:"function pageOpenEvent(name) {\n\t${1:// body...} \n}"
});
a.push({
	title:"function pageCloseEvent(name)",
	subTitle:"Javascript, Events",
	docHTML:"<p>Called when a page is closed.\n</p><p><b>Parameters:</b>\n</p><ul>\n<li> name: string - the page's id\n</li>\n</ul><p><b>Returns:</b>\n</p><ul>\n<li> false: don't close the page\n</li>\n<li> null: proceed to close the page\n</li>\n</ul><div dir=\"ltr\" class=\"mw-geshi mw-code mw-content-ltr\"><div class=\"javascript source-javascript\"><pre class=\"de1\"><span class=\"co1\">// page close event</span>\n<span class=\"kw1\">function</span> pageCloseEvent<span class=\"br0\">(</span>name<span class=\"br0\">)</span> <span class=\"br0\">{</span>\n\tconsole.<span class=\"me1\">log</span><span class=\"br0\">(</span><span class=\"st0\">\"closing \"</span><span class=\"sy0\">+</span>name<span class=\"br0\">)</span><span class=\"sy0\">;</span>\n\t<span class=\"kw1\">if</span> <span class=\"br0\">(</span>name <span class=\"sy0\">==</span><span class=\"st0\">\"sconfig\"</span><span class=\"br0\">)</span> <span class=\"br0\">{</span>\n\t\tconsole.<span class=\"me1\">log</span><span class=\"br0\">(</span><span class=\"st0\">\"nope 2\"</span><span class=\"br0\">)</span><span class=\"sy0\">;</span>\n\t\t<span class=\"kw1\">return</span> <span class=\"kw2\">false</span><span class=\"sy0\">;</span>\n\t<span class=\"br0\">}</span>\n<span class=\"br0\">}</span></pre></div></div>",
	content:"function pageCloseEvent(name) {\n\t${1:// body...} \n}"
});
a.push({
	title:"function pageBackEvent(name)",
	subTitle:"Javascript, Events",
	docHTML:"<p>Called when a page back is requested.\n</p><p><b>Parameters:</b>\n</p><ul>\n<li> name: string - the page's id\n</li>\n</ul><p><b>Returns:</b>\n</p><ul>\n<li> false: don't close the page\n</li>\n<li> null: proceed to close the page\n</li>\n</ul><div dir=\"ltr\" class=\"mw-geshi mw-code mw-content-ltr\"><div class=\"javascript source-javascript\"><pre class=\"de1\"><span class=\"co1\">// page back event</span>\n<span class=\"kw1\">function</span> pageBackEvent<span class=\"br0\">(</span>name<span class=\"br0\">)</span> <span class=\"br0\">{</span>\n\tconsole.<span class=\"me1\">log</span><span class=\"br0\">(</span><span class=\"st0\">\"backing from \"</span><span class=\"sy0\">+</span>name<span class=\"br0\">)</span><span class=\"sy0\">;</span>\n\t<span class=\"kw1\">if</span> <span class=\"br0\">(</span>name <span class=\"sy0\">==</span><span class=\"st0\">\"sconfig\"</span><span class=\"br0\">)</span> <span class=\"br0\">{</span>\n\t\tconsole.<span class=\"me1\">log</span><span class=\"br0\">(</span><span class=\"st0\">\"nope 3\"</span><span class=\"br0\">)</span><span class=\"sy0\">;</span>\n\t\t<span class=\"kw1\">return</span> <span class=\"kw2\">false</span><span class=\"sy0\">;</span>\n\t<span class=\"br0\">}</span>\n<span class=\"br0\">}</span></pre></div></div>",
	content:"function pageBackEvent(name) {\n\t${1:// body...} \n}"
});
a.push({
	title:"varSet(name,value)",
	subTitle:"Javascript, Functions",
	docHTML:"<p>Sets the value of a variable. If the name begins with <b>!</b>, the variable will be stored in the browser's cache, so that it'll available even after reloading the page or closing and reopening the browser.\n</p>",
	content:"varSet(${1:name},${2:value})"
});
a.push({
	title:"varGet(name)",
	subTitle:"Javascript, Functions",
	docHTML:"<p>Gets the value of a variable previously set with varSet.\n</p>",
	content:"varGet(${1:name})"
});
a.push({
	title:"uiSet(id,attr,value)",
	subTitle:"Javascript, Functions",
	docHTML:"<p>Sets a UI Attribute. See <a href=\"/3.7.0/index.php/Project\" title=\"Project\">Project</a>, <a href=\"/3.7.0/index.php/Page\" title=\"Page\" class=\"mw-redirect\">Page</a> or <a href=\"/3.7.0/index.php/UI_Objects\" title=\"UI Objects\">UI Objects</a> list of attributes.\n</p>",
	content:"uiSet(${1:id},${2:attr},${3:value})"
});
a.push({
	title:"webLog(string)",
	subTitle:"Javascript, Functions",
	docHTML:"<p>Adds a line to the daily log file, viewable from the Manager's <a href=\"/3.7.0/index.php/Log_Viewer\" title=\"Log Viewer\">Log Viewer</a>.\n</p>",
	content:"webLog(${1:string})"
});



// js

a.push({
	title:"fun",
	tabTrigger:"fun",
	content:"function ${1?:function_name}(${2:argument}) {\n\t${3:// body...}\n}"
});
a.push({
	title:"if",
	tabTrigger:"if",
	content:"if (${1:true}) {\n\t${0}\n}"
});
a.push({
	title:"ife",
	tabTrigger:"ife",
	content:"if (${1:true}) {\n\t${2}\n} else {\n\t${0}\n}"
});
a.push({
	title:"ter",
	tabTrigger:"ter",
	content:"${1:/* condition */} ? ${2:a} : ${3:b}"
});
a.push({
	title:"switch",
	tabTrigger:"switch",
	content:"switch (${1:expression}) {\n\tcase '${3:case}':\n\t\t${4:// code}\n\t\tbreak;\n\t${5}\n\tdefault:\n\t\t${2:// code}\n}"
});
a.push({
	title:"case",
	tabTrigger:"case",
	content:"case '${1:case}':\n\t${2:// code}\n\tbreak;\n${3}"
});
a.push({
	title:"wh",
	tabTrigger:"wh",
	content:"while (${1:/* condition */}) {\n\t${0:/* code */}\n}"
});
a.push({
	title:"try",
	tabTrigger:"try",
	content:"try {\n\t${0:/* code */}\n} catch (e) {}"
});
a.push({
	title:"do",
	tabTrigger:"do",
	content:"do {\n\t${2:/* code */}\n} while (${1:/* condition */});"
});
a.push({
	title:"setTimeout",
	tabTrigger:"setTimeout",
	content:"setTimeout(function() {${3:$TM_SELECTED_TEXT}}, ${1:10});"
});
a.push({
	title:"gett",
	tabTrigger:"gett",
	content:"getElementsBy${1:TagName}('${2}')${3}"
});
a.push({
	title:"get",
	tabTrigger:"get",
	content:"getElementBy${1:Id}('${2}')${3}"
});
a.push({
	title:"cl",
	tabTrigger:"cl",
	content:"console.log(${1});"
});
a.push({
	title:"ret",
	tabTrigger:"ret",
	content:"return ${1:result}"
});
a.push({
	title:"fori",
	tabTrigger:"fori",
	content:"for (var ${1:prop} in ${2:Things}) {\n\t${0:$2[$1]}\n}"
});
a.push({
	title:"jsonp",
	tabTrigger:"jsonp",
	content:"JSON.parse(${1:jstr});"
});
a.push({
	title:"jsons",
	tabTrigger:"jsons",
	content:"JSON.stringify(${1:object});"
});
a.push({
	title:"for-",
	tabTrigger:"for-",
	content:"for (var ${1:i} = ${2:Things}.length; ${1:i}--; ) {\n\t${0:${2:Things}[${1:i}];}\n}"
});
a.push({
	title:"for",
	tabTrigger:"for",
	content:"for (var ${1:i} = 0; $1 < ${2:Things}.length; $1++) {\n\t${3:$2[$1]}$0\n}"
});
a.push({
	title:"forr",
	tabTrigger:"forr",
	content:"for (var ${1:i} = ${2:Things}.length - 1; $1 >= 0; $1--) {\n\t${3:$2[$1]}$0\n}"
});



exports.scope = 'javascript';
});